/** Stream Format Pipe  class
* @author: Filip Dvorak
* @version: 1.0
*/

package xelfi.execution;

import java.io.*;

  /** This class reads data from an InputStram and passes it to an FormatedOutput interface. */
public class StreamFormatPipe implements Runnable
{
  private InputStream in;
  private FormatedOutput out;
  public StreamFormatPipe(InputStream input, FormatedOutput output)
  {
    in = input;
    out = output;
  }

    /** Strarts read/write cyclus. Returns when end of input stream is riched, and closes the FormatedOutput.
     */
  public void run()
  { 
    char arr[] = new char[128];
    int c = 0, count = 0;
    boolean toFlush = false;

    try
    {
      while(true)
      {
        count = 0;
        while(count  < 128 && (c = in.read()) != -1 && c != '\n')
        {
          arr[count++] = (char)c;
          if(/* in.available() */ 1 <= 0) { toFlush = true; break; }   
        }
        if(count == 128 || toFlush) 
        { 
          out.printtext(new String(arr, 0, count)); 
          toFlush = false;
          count = 0; 
        }
        else if(c == '\n')
        {
          out.printline(new String(arr, 0, count)); 
          count = 0;
        }
        else
        { 
          out.printtext(new String(arr, 0, count)); 
          out.close();
          in.close(); 
          return; 
        }
      }
    } 
    catch(IOException e) 
    { 
      out.printtext(new String(arr, 0, count)); 
      out.close();
      try { in.close(); } catch (IOException ex) {}; 
    }
  }
}
















































