/**
* Xelfi
*/

package xelfi.design.components.property;

import java.io.*;
import xelfi.util.Debug;

/**
 *
 * @version 	1.40, 08 Feb 1997 (from version 1.30 persistence is added)
 * @author 	Ian Formanek
 */
public class XStringPropertyType {
	public static String viewString(Object property) { return ((String)property); }

	public static void saveToStream(Object property, DataOutput stream) throws 
		IOException {
		stream.writeUTF((String)property);
		Debug.debug(Debug.PROPIO_SAVE, "XStringProperty saved: "+(String)property);
	}

	public static String loadFromStream(DataInput stream) throws 
		IOException {
		String property = stream.readUTF();
		Debug.debug(Debug.PROPIO_LOAD, "XStringProperty loaded: "+(String)property);
		return property;
	}
}
