/**
* Xelfi programming environment
*/

package xelfi.editor;
/**
* Searches for first non space character or end of line.
*
* @version 1.0
* @author Jaroslav Tulach
*/

class AcceptorNonspace implements Acceptor {
  /** Searches for the first non space character.
  * @param ch the character at specified position
  * @return false if ch is still space
  */
  public boolean accept (char ch) {
    return (int) ch > (int)' ' || ch == '\n';
  };
};


